> ## Documentation Index
> Fetch the complete documentation index at: https://docs.referralloop.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# List Signups

> Retrieve all signups for a specific waitlist



## OpenAPI

````yaml GET /waitlists/{waitlistId}/signups
openapi: 3.1.0
info:
  title: ReferralLoop API
  description: >
    The ReferralLoop API allows you to integrate waitlist and referral
    functionality into your application.


    ## Authentication


    All API requests must include your API key in the Authorization header:


    ```

    Authorization: Bearer pk_live_YOUR_API_KEY

    ```


    ## Rate Limits


    Rate limits vary by plan:

    - Starter: 1,000 requests/hour

    - Growth: 10,000 requests/hour

    - Pro: 100,000 requests/hour


    Rate limit information is included in response headers:

    - `X-RateLimit-Limit`: Maximum requests allowed

    - `X-RateLimit-Remaining`: Requests remaining

    - `X-RateLimit-Reset`: When the limit resets (ISO 8601)
  version: 1.0.0
  contact:
    name: ReferralLoop Support
    url: https://www.referralloop.dev
  license:
    name: Proprietary
servers:
  - url: https://www.referralloop.dev/api/v1
    description: Production server
security: []
tags:
  - name: Waitlists
    description: Manage waitlists
  - name: Signups
    description: Manage signups
paths:
  /waitlists/{waitlistId}/signups:
    get:
      tags:
        - Signups
      summary: List Signups
      description: Retrieve all signups for a specific waitlist
      operationId: listSignups
      parameters:
        - $ref: '#/components/parameters/WaitlistId'
        - $ref: '#/components/parameters/Limit'
        - $ref: '#/components/parameters/Offset'
      responses:
        '200':
          description: Successful response
          headers:
            X-RateLimit-Limit:
              description: Maximum number of requests allowed
              schema:
                type: integer
            X-RateLimit-Remaining:
              description: Number of requests remaining
              schema:
                type: integer
            X-RateLimit-Reset:
              description: ISO 8601 timestamp when rate limit resets
              schema:
                type: string
                format: date-time
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SignupsListResponse'
              examples:
                success:
                  value:
                    signups:
                      - id: 789e0123-e89b-12d3-a456-426614174000
                        email: user@example.com
                        name: John Doe
                        position: 1
                        referral_code: ABC123
                        referral_count: 5
                        status: waiting
                        created_at: '2024-01-15T10:00:00Z'
                    total: 150
                    limit: 50
                    offset: 0
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
        '429':
          $ref: '#/components/responses/RateLimitExceeded'
        '500':
          $ref: '#/components/responses/InternalServerError'
      security:
        - bearerAuth: []
components:
  parameters:
    WaitlistId:
      name: waitlistId
      in: path
      required: true
      description: The ID of the waitlist
      schema:
        type: string
        format: uuid
      example: 123e4567-e89b-12d3-a456-426614174000
    Limit:
      name: limit
      in: query
      description: 'Number of results to return (default: 100, max: 1000)'
      required: false
      schema:
        type: integer
        minimum: 1
        maximum: 1000
        default: 100
      example: 50
    Offset:
      name: offset
      in: query
      description: 'Pagination offset (default: 0)'
      required: false
      schema:
        type: integer
        minimum: 0
        default: 0
      example: 0
  schemas:
    SignupsListResponse:
      type: object
      required:
        - signups
        - total
        - limit
        - offset
      properties:
        signups:
          type: array
          items:
            $ref: '#/components/schemas/Signup'
        total:
          type: integer
          description: Total number of signups
          example: 150
        limit:
          type: integer
          description: Number of results returned
          example: 50
        offset:
          type: integer
          description: Pagination offset
          example: 0
    Signup:
      type: object
      required:
        - id
        - email
        - position
        - referral_code
        - status
        - created_at
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the signup
          example: 789e0123-e89b-12d3-a456-426614174000
        email:
          type: string
          format: email
          description: Email address of the signup
          example: user@example.com
        name:
          type: string
          nullable: true
          description: Full name of the signup
          example: John Doe
        position:
          type: integer
          description: Current position in the waitlist
          example: 1
        referral_code:
          type: string
          description: Unique referral code for this signup
          example: ABC123
        referral_url:
          type: string
          format: uri
          nullable: true
          description: Full URL for the referral link
          example: https://www.referralloop.dev/w/product-launch?ref=ABC123
        referral_count:
          type: integer
          nullable: true
          description: Number of referrals made by this signup
          example: 5
        status:
          type: string
          enum:
            - waiting
            - approved
            - rejected
          description: Status of the signup
          example: waiting
        created_at:
          type: string
          format: date-time
          description: ISO 8601 timestamp when the signup was created
          example: '2024-01-15T10:00:00Z'
        metadata:
          type: object
          nullable: true
          description: Custom metadata associated with the signup
          additionalProperties: true
          example:
            source: landing_page
            campaign: summer_launch
    Error:
      type: object
      required:
        - error
      properties:
        error:
          type: string
          description: Error message describing what went wrong
          example: Invalid API key
        message:
          type: string
          description: Additional error details
          example: Upgrade your plan to use the API
        upgrade_url:
          type: string
          format: uri
          description: URL to upgrade plan (for 403 errors)
          example: https://www.referralloop.dev/dashboard/billing
        limit:
          type: integer
          description: Rate limit (for 429 errors)
          example: 1000
        reset_at:
          type: string
          format: date-time
          description: When rate limit resets (for 429 errors)
          example: '2024-01-15T11:00:00Z'
        signup:
          $ref: '#/components/schemas/Signup'
          description: Existing signup information (for 409 errors)
  responses:
    Unauthorized:
      description: Unauthorized - Invalid or missing API key
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
          examples:
            missingKey:
              value:
                error: Missing or invalid authorization header
            invalidKey:
              value:
                error: Invalid API key
    NotFound:
      description: Not Found - Resource doesn't exist
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
          examples:
            waitlistNotFound:
              value:
                error: Waitlist not found
            signupNotFound:
              value:
                error: Signup not found
    RateLimitExceeded:
      description: Too Many Requests - Rate limit exceeded
      headers:
        X-RateLimit-Limit:
          description: Maximum number of requests allowed
          schema:
            type: integer
        X-RateLimit-Remaining:
          description: Number of requests remaining (will be 0)
          schema:
            type: integer
        X-RateLimit-Reset:
          description: ISO 8601 timestamp when rate limit resets
          schema:
            type: string
            format: date-time
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
          examples:
            rateLimit:
              value:
                error: Rate limit exceeded
                limit: 1000
                reset_at: '2024-01-15T11:00:00Z'
    InternalServerError:
      description: Internal Server Error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
          examples:
            serverError:
              value:
                error: Failed to fetch waitlists
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >
        Use your API key as the bearer token. API keys can be generated in your
        dashboard.


        Example: `Authorization: Bearer pk_live_YOUR_API_KEY`

````